﻿Imports System.Collections.ObjectModel
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.IO
<Serializable>
Public Class GridLayout
#If DEBUG Then
    'Public Shared ReadOnly GridSaveFile As String = $"{My.Settings.Datenverzeichnis}\gridlayout.bin"
    Public Shared ReadOnly GridSaveFile As String = $"..\..\Daten\gridlayout.bin"
#Else
    'TODO normaler Anwendungspfad
#End If


    <Serializable>
    Friend Class GridLayout
        Public Property GridName As String
        Public Widths As New List(Of Integer)

        ' Some Serializers will require a simple ctor
        Public Sub New()
            Widths = New List(Of Integer)
        End Sub

        Public Sub SaveLayout(name As String, dgv As DataGridView)
            ' something the code uses to map them
            ' other than "DataGridView1" of which there may be several
            GridName = name

            ' ToDo: loop thru DGV save widths to Widths
        End Sub
    End Class


    Private mCol As Collection(Of GridLayout)
    Private myFile As String

    Public Sub New(filename As String)
        'myFile = GridSaveFile
        mCol = New Collection(Of GridLayout)
    End Sub

    Private Function IndexOf(grdName As String) As Integer
        For n As Integer = 0 To mCol.Count - 1
            If grdName = mCol(n).GridName Then
                Return n
            End If
        Next
        Return -1        ' not found

        ' alternatively find by name:
        'Dim item = mCol.FirstOrDefault(Function(i) i.GridName = grdName)
        'Return item
    End Function

    Public Sub StoreLayout(name As String, dgv As DataGridView)
        Dim ndx As Integer = IndexOf(name)
        If ndx <> -1 Then
            mCol.RemoveAt(ndx)          ' throw away old one
        End If

        Dim grd As New GridLayout
        grd.SaveLayout(name, dgv)
        mCol.Add(grd)
        Save()
    End Sub

    Public Sub RestoreLayout(name As String, dgv As DataGridView)
        Load()
        Dim ndx As Integer = IndexOf(name)
        If ndx = -1 Then
            Exit Sub
        End If

        For n As Integer = 0 To mCol(ndx).Widths.Count - 1
            ' loop thru grid and set the columns
            ' maybe check that the col sizes are equal
            dgv.Columns(n).Width = mCol(n).Widths(n)
        Next n

    End Sub

    Public Sub Save()
        ' ToDo: Make a backup (?)
        ' Add a Try/Catch and convert to function
        Dim bf As New BinaryFormatter
        Using fs As New FileStream(myFile, FileMode.OpenOrCreate)
            bf.Serialize(fs, mCol)
        End Using

    End Sub

    Public Sub Load()
        Dim bf As New BinaryFormatter
        Dim fi As New FileInfo(myFile)
        If fi.Exists Then
            Using fs As New FileStream(myFile, FileMode.Open)
                mCol = CType(bf.Deserialize(fs), Collection(Of GridLayout))
            End Using
        End If
    End Sub
End Class
